
local Const = SchtenksBars.Const
--#region Cast Events
function SchtenksBars.Events.UNIT_SPELLCAST_START(event, unit, castGUID, spellID)
	local class = nil
	if UnitIsPlayer(unit) then
		class, _ = UnitClassBase(unit)
	end

	---@type CastBar
	local bar = SchtenksBars.Bars[Const.CastBars][unit]
	if bar == nil then return end
	local name, text, texture, startTime, endTime, isTradeSkill, castID, notInterruptible = UnitCastingInfo(unit)
	endTime = endTime/1000
	startTime = startTime/1000
	local duration = endTime - startTime
	local elapsed = GetTime() - startTime
	bar:SetInfo(name, unit, class, notInterruptible, false)
	bar:SetIcon(texture)
	bar:SetFullDuration(duration)
	bar:SetDuration(elapsed)
	bar:Start(startTime)
end
SchtenksBars.Events.UNIT_SPELLCAST_DELAYED = SchtenksBars.Events.UNIT_SPELLCAST_START

function SchtenksBars.Events.UNIT_SPELLCAST_CHANNEL_START(event, unit, castGUID, spellID)
	---@type CastBar
	local class = nil
	if UnitIsPlayer(unit) then
		class, _ = UnitClassBase(unit)
	end
	
	local bar = SchtenksBars.Bars[Const.CastBars][unit]
	if bar == nil then return end
	local name, text, texture, startTime, endTime, isTradeSkill, notInterruptible, spellID = UnitChannelInfo(unit)
	endTime = endTime/1000
	startTime = startTime/1000
	local duration = endTime - startTime
	local elapsed = GetTime() - startTime
	bar:SetInfo(name, unit, class, notInterruptible, true)
	bar:SetIcon(texture)
	bar:SetFullDuration(duration)
	bar:SetDuration(elapsed)
	bar:Start(startTime)
end
SchtenksBars.Events.UNIT_SPELLCAST_CHANNEL_UPDATE = SchtenksBars.Events.UNIT_SPELLCAST_CHANNEL_START

function SchtenksBars.Events.UNIT_SPELLCAST_STOP(event, unit, castGUID, spellID)
	---@type CastBar
	local bar = SchtenksBars.Bars[Const.CastBars][unit]
	if bar == nil then return end
	bar:Stop()
end
function SchtenksBars.Events.UNIT_SPELLCAST_FAILED(event, unit, castGUID, spellID)
	---@type CastBar
	local bar = SchtenksBars.Bars[Const.CastBars][unit]
	if bar == nil then return end
    if bar.castID == castGUID then
		SchtenksBars.Events.UNIT_SPELLCAST_STOP(event, unit, castGUID, spellID)
        --bar:SetForegroundColor(1,0,0,1)
    end
end
SchtenksBars.Events.UNIT_SPELLCAST_INTERRUPTED = SchtenksBars.Events.UNIT_SPELLCAST_FAILED
SchtenksBars.Events.UNIT_SPELLCAST_CHANNEL_STOP = SchtenksBars.Events.UNIT_SPELLCAST_STOP

--#region----------COULD BE USED FOR CLASSIC---------
	-- function SchtenksBars.Events.UNIT_SPELLCAST_INTERRUPTIBLE(event, unit)
	-- 	local Const = SchtenksBars.Const
	-- 	local settings = SchtenksBars.DB.profile[unit]
	-- 	---@type CastBar
	-- 	local bar = SchtenksBars.Bars[Const.CastBars][unit]
	-- 	if bar == nil then return end
	-- end
	-- function SchtenksBars.Events.UNIT_SPELLCAST_NOT_INTERRUPTIBLE(event, unit)
	-- 	---@type CastBar
	-- 	local bar = SchtenksBars.Bars[Const.CastBars][unit]
	-- 	if bar == nil then return end
	-- 	local Const = SchtenksBars.Const        
	-- 	local settings = SchtenksBars.DB.profile[unit]

--#endregion-------COULD BE USED FOR CLASSIC---------

function SchtenksBars.Events.PLAYER_TARGET_CHANGED()
    if UnitCastingInfo("target") then return SchtenksBars.Events.UNIT_SPELLCAST_START(nil, "target") end
    if UnitChannelInfo("target") then return SchtenksBars.Events.UNIT_SPELLCAST_CHANNEL_START(nil,"target") end
	SchtenksBars.Events.UNIT_SPELLCAST_STOP(nil, "target")
end

function SchtenksBars.Events.PLAYER_FOCUS_CHANGED()
    if UnitCastingInfo("focus") then return SchtenksBars.Events.UNIT_SPELLCAST_START(nil, "focus") end
    if UnitChannelInfo("focus") then return SchtenksBars.Events.UNIT_SPELLCAST_CHANNEL_START(nil, "focus") end
	SchtenksBars.Events.UNIT_SPELLCAST_STOP(nil, "focus")
end

function SchtenksBars.Events.UNIT_SPELLCAST_SUCCEEDED(event, unit, castID)
	---@type Bar
	local bar = SchtenksBars.Bars[Const.CastBars][unit]
	if bar == nil then return end
    if bar.IsChannel then return end
    if bar.castID == castID then
        SchtenksBars.Events.UNIT_SPELLCAST_STOP(event, unit, castID)
    end
end
--#endregion






