
local Const = SchtenksBars.Const

function SchtenksBars.Events.MIRROR_TIMER_START(self, timer ,value ,maxvalue, scale, paused, timerLabel)
    ---@type MirrorBars
    local mirror = SchtenksBars.Bars[Const.Mirror]
    mirror:Start(timer, value, maxvalue, scale, paused, timerLabel)
end

function SchtenksBars.Events.MIRROR_TIMER_PAUSE(self, timer, pauses)
    ---@type MirrorBars
	local mirror = SchtenksBars.Bars[Const.Mirror]
	if mirror and mirror.Enabled then
		mirror:Pause(timer, pauses)
	end
end

function SchtenksBars.Events.MIRROR_TIMER_STOP(self, timer)
	---@type MirrorBars
	local mirror = SchtenksBars.Bars[Const.Mirror]
	if mirror and mirror.Enabled then
		mirror:Stop(timer)
	end
end

local function MirrorTimer_Show(timer, value, maxvalue, scale, paused, label)
	-- Pick a free dialog to use
	local dialog = nil;
	-- Find an open dialog of the requested type
	for index = 1, MIRRORTIMER_NUMTIMERS, 1 do
		local frame = _G["MirrorTimer"..index];
		if ( frame:IsShown() and (frame.timer == timer) ) then
			dialog = frame;
			break;
		end
	end
	if ( not dialog ) then
		-- Find a free dialog
		for index = 1, MIRRORTIMER_NUMTIMERS, 1 do
			local frame = _G["MirrorTimer"..index];
			if ( not frame:IsShown() ) then
				dialog = frame;
				break;
			end
		end
	end
	if ( not dialog ) then
		return nil;
	end
	dialog.timer = timer;
	dialog.value = (value / 1000);
	dialog.scale = scale;
	if ( paused > 0 ) then
		dialog.paused = 1;
	else
		dialog.paused = nil;
	end
	-- Set the text of the dialog
	local text = _G[dialog:GetName().."Text"];
	text:SetText(label);
	-- Set the status bar of the dialog
	local statusbar = _G[dialog:GetName().."StatusBar"];
	local color = MirrorTimerColors[timer];
	statusbar:SetMinMaxValues(0, (maxvalue / 1000));
	statusbar:SetValue(dialog.value);
	statusbar:SetStatusBarColor(color.r, color.g, color.b);
	dialog:Show();
	return dialog;
end
